
Robotics Service Bus - Bug #1251
The current versioning scheme of RSC/RSB is inconsistent
11/22/2012 11:32 AM - J. Wienke

Status: Resolved Start date: 11/22/2012
Priority: Normal Due date:
Assignee: J. Moringen % Done: 100%
Category: Build System Estimated time: 0.00 hour
Target version: rsb-0.9
Description

With the current git-based versioning scheme the following situation occurs:

    -  The master branch is updated after the release of a stable version to the next version, e.g. 0.8 right now.
    -  From then on this branch gets an incremented patch version with every new commit to have distinct versions.
    -  With the new release of the master, the version gets reset to 0.8.0 and suddenly we have conflicting versions.

This issue already results in the problem that once we release RSB 0.8, the debian packages will not be updated automatically
anymore.
I had a quick discussion about this issue with David and a solution might be the following:
    -  For released versions nothing changes from the current theme.
    -  For master, the patch version will not be affected by the git commits and remains at 0. Instead we have the following options to
disambiguate master builds:
        -  For debian packages, set the build id after the main version as -bXXX (we already planned this and for release updated to
-rXXX, so that from debian's point of view this is a more recent version)
        -  Include the commit hash in the package name and make it accessible at runtime. For including it in the package name we need
to carefully think about how to do this so that after release really a new version is created.

This slightly complicates the release process of a new version because starting with the release a different versioning scheme needs
to be switched on. Maybe the macros used to increment the patch version from git can be tweaked to only increment the version on
release branches?

Related issues:
Blocked by Robotics Systems Commons - Enhancement # 1256: Adapt GitProjectVer... Resolved 11/22/2012
Blocks Robotics Systems Types - Bug # 1311: debian packages out-dated Resolved 12/19/2012
Blocks Robotics Service Bus - Bug # 1445: Non-existent Debian package is ment... Resolved 02/28/2013

Associated revisions
Revision d3b23c3b - 11/23/2012 10:07 AM - J. Wienke

Implement new versioning scheme from git for rsb-java.

Patch versions are now only incremented on release branches.

refs #1251

Revision 90796fd8 - 11/23/2012 10:10 AM - J. Wienke

Implement new versioning scheme from git for rsb-java.

Patch versions are now only incremented on release branches.
refs #1251

Revision 50dcea48 - 11/23/2012 01:15 PM - J. Wienke

Implement proper version handling along the new ideas for python.

The project version is now defined through git describe. The patch
version is only incremented for release branches. The commit is defined
all the time. Caching as in all other languages is possible. Version
information is made accessible at runtime through a configured python
module.

refs #1251

Revision 7a146170 - 11/23/2012 01:36 PM - J. Wienke

Make the last commit available at runtime.

The commit ID is transported using the jar manifest.

refs #1251

Revision 2b7b64c7 - 11/23/2012 02:09 PM - J. Wienke

Construct paths using os.path.join to work on windows.

refs #1251

Revision 0e582fc4 - 11/26/2012 03:15 PM - D. Klotz

Merge branch 'wip-maven', updating the Maven build, e.g. to also
implement the correct versioning scheme.

refs #1251
refs #1252

Revision 0189b790 - 01/15/2013 05:03 PM - J. Wienke

Informal version bump to 0.9.

refs #1251

Revision a1f2f9d3 - 01/15/2013 05:04 PM - J. Wienke

Informal version bump to 0.9.

refs #1251
Revision d22e74fb - 01/15/2013 05:05 PM - J. Wienke

Informal version bump to 0.9.

refs #1251

Revision c842190c - 01/15/2013 05:05 PM - J. Wienke

Informal version bump to 0.9.

refs #1251

Revision 08b7c05d - 01/15/2013 05:06 PM - J. Wienke

Informal version bump to 0.9.

refs #1251

Revision 4c974dce - 01/15/2013 05:06 PM - J. Wienke

Informal version bump to 0.9.

refs #1251

Revision 60bdf798 - 01/15/2013 05:07 PM - J. Wienke

Informal version bump to 0.9.

refs #1251

Revision 850701fd - 01/15/2013 05:09 PM - J. Wienke

Informal version bump to 0.9.

refs #1251

Revision 04f6997b - 01/15/2013 05:14 PM - J. Wienke

Informal version bump to 0.9.

refs #1251

Revision 5f4339b6 - 01/15/2013 05:14 PM - J. Wienke

Informal version bump to 0.9.
refs #1251

Revision 4b40bc4f - 01/15/2013 05:15 PM - J. Wienke

Informal version bump to 0.9.

refs #1251

Revision 2f6130b7 - 01/15/2013 05:15 PM - J. Wienke

Informal version bump to 0.9.

refs #1251

Revision 67808c9e - 01/15/2013 05:18 PM - J. Wienke

Informal version bump to 0.9.

refs #1251

Revision 72f7b9a3 - 03/06/2013 12:49 AM - J. Moringen

Bumped version 0.8 -> 0.9 in *.asd

refs #1251, fixes #1445

    -  cl-rsb-common.asd (header): updated copyright
  (version-minor): change 8 -> 9

    -  cl-rsb-formatting.asd: likewise
    -  cl-rsb-stats.asd: likewise
    -  cl-rsb-tools-call.asd: likewise
    -  cl-rsb-tools-info.asd: likewise
    -  cl-rsb-tools-logger.asd: likewise
    -  cl-rsb-tools-main.asd: likewise
    -  cl-rsb-tools-send.asd: likewise

Revision 9fdeb3c7 - 03/06/2013 12:50 AM - J. Moringen

Bumped version 0.8 -> 0.9 in cl-rsb.asd

refs #1251

    -  cl-rsb.asd (version-minor): changed 8 -> 9

Revision 10220c24 - 03/06/2013 12:52 AM - J. Moringen

Bumped version 0.8 -> 0.9 in cl-rsbag.asd

04/24/2024 4/10



refs #1251

    -  cl-rsbag.asd (version-minor): changed 8 -> 9

Revision d10dc1e4 - 03/06/2013 02:27 AM - J. Moringen

Bumped version 0.8 -> 0.9 in rsb-yarp.asd

refs #1251

    -  rsb-yarp.asd (header): updated copyright
  (version-minor): changed 8 -> 9

Revision 48ccee1d - 03/06/2013 02:28 AM - J. Moringen

Bumped version 0.8 -> 0.9 in rsb-ros.asd

refs #1251

    -  rsb-ros.asd (header): updated copyright
  (version-minor): changed 8 -> 9

Revision d5ed8440 - 03/06/2013 09:39 AM - J. Moringen

More accurate "git describe" processing in CMakeLists.txt

refs #1251

Run git_based_version and git_version_components repeatedly when
required.

    -  CMakeLists.txt (git_version_components): turned into function
  (git_based_version): likewise; describe version relative to specific
  tag
  (configure_lisp): turned into function
  (configure_lisp_redirect): likewise
  (execute_lisp): likewise

Revision 5e626cd1 - 03/06/2013 10:09 AM - J. Moringen

More accurate "git describe" processing in CMakeLists.txt

refs #1251

Run git_based_version and git_version_components repeatedly when
required.

    -  CMakeLists.txt (git_version_components): turned into function
  (git_based_version): likewise; describe version relative to specific
  tag
  (configure_lisp): turned into function
  (configure_lisp_redirect): likewise
  (execute_lisp): likewise

Revision 073eb041 - 03/06/2013 10:54 AM - J. Moringen

More accurate "git describe" processing in CMakeLists.txt

refs #1251

Run git_based_version and git_version_components repeatedly when
required.

    -  CMakeLists.txt (git_version_components): turned into function
  (git_based_version): likewise; describe version relative to specific
  tag
  (configure_lisp): turned into function
  (configure_lisp_redirect): likewise
  (execute_lisp): likewise

Revision 0c3da85b - 03/06/2013 10:55 AM - J. Moringen

Bumped version 0.8 -> 0.9 in *.asd

refs #1251

    -  cl-rsbag-common.asd (header): updated copyright
  (version-minor): change 8 -> 9

    -  cl-rsbag-tools-cat.asd: likewise
    -  cl-rsbag-tools-info.asd: likewise
    -  cl-rsbag-tools-main.asd: likewise
    -  cl-rsbag-tools-merge.asd: likewise
    -  cl-rsbag-tools-play.asd: likewise
    -  cl-rsbag-tools-record.asd: likewise

Revision 4ec4246e - 03/06/2013 11:42 AM - J. Moringen

Added support for rsb-event-0.8 serialization

refs #1251

    -  compat/0.8: new directory; contains data and code for rsb-event-0.8
  serialization

    -  src/transform/rsb-event-multi-version.lisp (header): updated
  copyright
  (toplevel): define rsb-event-0.8 serialization

Revision 3c2b8707 - 03/06/2013 11:47 AM - J. Moringen
Added test data files in test/data/0.9

refs #1251

    -  test/data/0.9/empty-channel.tide: new file; test data for the 0.9
  serialization version

    -  test/data/0.9/empty.tide: likewise
    -  test/data/0.9/no-type.tide: likewise
    -  test/data/0.9/single-event.tide: likewise
    -  test/data/0.9/unsupported-type.tide: likewise

Revision 5a28aeec - 03/06/2013 12:37 PM - J. Moringen

More accurate "git describe" processing in CMakeLists.txt

refs #1251

Run git_based_version and git_version_components repeatedly when
required.

    -  CMakeLists.txt (git_version_components): turned into function
  (git_based_version): likewise; describe version relative to specific
  tag
  (configure_lisp): turned into function
  (configure_lisp_redirect): likewise
  (execute_lisp): likewise

Revision 44971c11 - 03/07/2013 12:12 PM - J. Moringen

More accurate "git describe" processing in CMakeLists.txt

refs #1251

Run git_based_version and git_version_components repeatedly when
required.

    -  CMakeLists.txt (git_version_components): turned into function
  (git_based_version): likewise; describe version relative to specific
  tag
  (configure_lisp): turned into function
  (configure_lisp_redirect): likewise
  (execute_lisp): likewise

Revision ace7e09f - 03/07/2013 12:17 PM - J. Moringen

More accurate "git describe" processing in CMakeLists.txt

refs #1251

Run git_based_version and git_version_components repeatedly when
required.

    -  CMakeLists.txt (git_version_components): turned into function
  (git_based_version): likewise; describe version relative to specific
  tag
  (configure_lisp): turned into function
  (configure_lisp_redirect): likewise
  (execute_lisp): likewise

Revision 4338294c - 03/07/2013 12:51 PM - J. Moringen

Bumped version 0.8 -> 0.9 in *.asd

refs #1251

    -  rsb-xml.asd (version-minor): change 8 -> 9

Revision 08dc3f46 - 03/07/2013 12:51 PM - J. Moringen

More accurate "git describe" processing in CMakeLists.txt

refs #1251

Run git_based_version and git_version_components repeatedly when
required.

    -  CMakeLists.txt (git_version_components): turned into function
  (git_based_version): likewise; describe version relative to specific
  tag
  (configure_lisp): turned into function
  (configure_lisp_redirect): likewise
  (execute_lisp): likewise

History
#1 - 11/22/2012 11:33 AM - J. Wienke
- Description updated

#2 - 11/22/2012 11:49 AM - J. Wienke

One issue remains with the above proposal: After branching off the release branch the first version there needs to be 0.8.1 to get the update. This
doesn't happen automatically. So we need to modify the macros to e.g. add 1 to the revisions they found since the branch.

#3 - 11/22/2012 02:34 PM - J. Wienke

We probably should skip version 0.8 after fixing this versioning issue to prevent manual interventions for existing debian installations.

#4 - 11/22/2012 02:37 PM - J. Wienke
We decided against using patch version directly after release as it sounds weird and most packaging solutions have other means to disambiguate
trunk vs. release versions.

#5 - 11/22/2012 02:39 PM - J. Wienke
- Assignee set to J. Wienke

#6 - 11/22/2012 04:09 PM - J. Wienke
- Status changed from New to In Progress

#7 - 11/23/2012 02:39 PM - J. Wienke

All necessary changes to the automatic versioning have been made. We will wait with the version bump a few more days to see if everything really
works as expected.

#8 - 01/10/2013 05:36 PM - J. Wienke

Any objections to do this now?

#9 - 01/10/2013 05:39 PM - J. Moringen

I don't care as long as I don't have to manage the next release.

#10 - 01/10/2013 06:51 PM - D. Klotz

To do what excactly, now? I thought this was more or less implemented in all languages, what's left?

#11 - 01/10/2013 06:57 PM - J. Wienke

Version bump.

#12 - 01/14/2013 01:52 PM - Anonymous

go for it!
@Johannes: Can you master this release?

#13 - 01/15/2013 04:58 PM - J. Wienke

It's actually easy. It just requires to change the version numbers. I will try to do it now.

#14 - 01/15/2013 05:27 PM - J. Wienke
- Assignee changed from J. Wienke to J. Moringen
- % Done changed from 0 to 70

I have bumped the version for everything I knew of apart from the CL components because I did not know how to do it there.
What I did was:
    -  rsb
    -  rsb-xml
    -  rsc
    -  rst
    -  gstreamer
    -  opencv tools
    -  redmine version

@Jan, please change the CL components accordingly

We should wait with closing the issue until all builds are back to normal on the jenkins.

#15 - 01/16/2013 11:22 AM - J. Wienke

Everything apart from CL and known problems seems to compile again on jenkins.

#16 - 01/16/2013 03:02 PM - J. Moringen

I believe the CL jobs have been broken by the Jenkins update. Probably because HTTP access to workspaces works differently now.

#17 - 01/16/2013 03:10 PM - J. Wienke

API keys have changed. Can this explain the problems?

#18 - 01/16/2013 03:29 PM - J. Moringen

No, but that discussion would be off-topic for this issue. I will take care of the build jobs later.

#19 - 03/07/2013 05:44 PM - J. Moringen
- Status changed from In Progress to Resolved
- % Done changed from 70 to 100
